/**
 * Arduino I2C Slave 01
 * v. 1.0
 * Copyright (C) 2015 Robert Ulbricht
 *
 * I2C communication with second Arduino
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <Wire.h>

const byte MY_ADDRESS = 42;
int how;
boolean signal=false;
byte b;

void setup () 
{
  Serial.begin(9600); 
  Serial.println("I2C Slave 01");
  Wire.begin (MY_ADDRESS);
  // set up receive handler
  Wire.onReceive (receiveEvent);
}  // end of setup

void loop() 
{
  if(signal)
  {
    Serial.print("how=");
    Serial.print(how);
    Serial.print(", b=");
    Serial.print(b);
    Serial.println("");
    signal=false;
  }
}

// called by interrupt service routine when incoming data arrives
void receiveEvent (int howMany)
{
  how=howMany;
  for (int i = 0; i < howMany; i++)
  {
    b = Wire.read ();
  }  // end of for loop
  signal=true;
}  // end of receiveEvent

